#include "jxmlparser.h"

#include <iostream>

#include <stdio.h>
#include <math.h>
#include <string>
#include <sstream>

#include <fstream>
#include <stdlib.h>
#include <string>

#include "lerXml.h"
#include "pontoArticulacao.h"
#include "orientacaoMao.h"
#include "expressaoFacial.h"

using namespace std;
using namespace jcommon;

ReadXml::ReadXml(char* xmlFilename) {
    this->xmlFilename = xmlFilename;
//    flagEndOfRead = false;
}

ReadXml::~ReadXml() {
}

bool ReadXml::StartsWith(const std::string& text, const std::string& token) {
    if (text.length() < token.length())
        return false;
    return (text.compare(0, token.length(), token) == 0);
}

string convertInt(int number) {
    stringstream ss; //create a stringstream
    ss << number; //add number to the stream
    return ss.str(); //return a string with the contents of the stream
}

int ReadXml::getLastHandshapeNumber(string ladoCorpo) {
    string s;
    if (ladoCorpo.compare("direito") == 0) {
        s = "Dir";
    } else
        s = "Esq";


    string s1 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibConfigMao";
    s1 += s;
    cout << s1 << endl;

    std::ifstream readline(s1.c_str(), std::ifstream::in);
    std::vector<std::string> lines;
    if (readline) {
        std::string s;

        while (getline(readline, s)) {
            if (StartsWith(s, "conf_")) {
                lines.push_back(s);
            }
        }
        readline.close();
        return lines.size();

    }
    return -1;
}

int ReadXml::getLastOrientationHandNumber(string ladoCorpo) {
    string s;
    if (ladoCorpo.compare("direito") == 0) {
        s = "Dir";
    } else
        s = "Esq";

    string s1 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibOrientacao";
    s1 += s;
    cout << s1 << endl;

    std::ifstream readline(s1.c_str(), std::ifstream::in);

    std::vector<std::string> lines;
    if (readline) {
        std::string s;

        while (getline(readline, s)) {
            if (StartsWith(s, "Ori_")) {
                lines.push_back(s);
            }
        }
        readline.close();
        return lines.size();

    }
    return -1;
}

int ReadXml::getLastLocationPointNumber(string ladoCorpo) {
    string s;
    if (ladoCorpo.compare("direito") == 0) {
        s = "Dir";
    } else
        s = "Esq";

    string s1 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibPontoArticulacao";
    s1 += s;
    cout << s1 << endl;

    std::ifstream readline(s1.c_str(), std::ifstream::in);

    std::vector<std::string> lines;
    if (readline) {
        std::string s;

        while (getline(readline, s)) {
            if (StartsWith(s, "Pa_")) {
                lines.push_back(s);
            }
        }
        readline.close();
        return lines.size();

    }
    return -1;
}

int ReadXml::getLastFacialExpressionNumber() {
    string s1 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibExpressaoFacial";

    cout << s1 << endl;

    std::ifstream readline(s1.c_str(), std::ifstream::in);

    std::vector<std::string> lines;
    if (readline) {
        std::string s;

        while (getline(readline, s)) {
            if (StartsWith(s, "Exp_")) {
                lines.push_back(s);
            }
        }
        readline.close();
        return lines.size();

    }
    return -1;


}

void ReadXml::Leitura() {
   
    expressaoFacial *expFacial;
    string nomeParamDir,
            nomeParamEsq,
            nomeDoSinal,
            tipoDoMovimentoDir,
            tipoDoMovimentoEsq,
            maoUtilizada,
            configDedosDir,
            configDedosEsq,
            orientacaoPalmaDir,
            orientacaoPalmaEsq,
            sentidoPalmaDir,
            sentidoPalmaEsq,
            sentidoPontaDedosDir,
            sentidoPontaDedosEsq,
            orientacaoMaoDir,
            orientacaoMaoEsq,
            estadoPontoArticulacaoDir,
            estadoPontoArticulacaoEsq,
            subdivisaoDir,
            subdivisaoEsq,
            localizacaoDir,
            localizacaoEsq,
            pontoArticulacaoDirInicial,
            pontoArticulacaoDirFinal,
            pontoArticulacaoEsqInicial,
            pontoArticulacaoEsqFinal,
            sincronismo,
            flagRepeticaoDir,
            flagRepeticaoEsq,
            tipoRepeticaoDir,
            tipoRepeticaoEsq,
            tamanhoRaioDir,
            tamanhoRaioEsq,
            sentidoMovimentoDir,
            sentidoMovimentoEsq,
            orientacaoMovimentoDir,
            orientacaoMovimentoEsq,
            direcaoMovimentoDir,
            direcaoMovimentoEsq,
            expressaoFacial;

    XmlAttribute * atr;

    XmlElement *pt_nivel1, *pt_nivel2, *pt_nivel3;
    PontoArticulacao *pa = NULL;
    OrientacaoMao *oriMao = NULL;

    XmlDocument doc(this->xmlFilename);


    if (!doc.LoadFile()) {
	cout << "Arquivo passado: "<<this->xmlFilename << endl;
        printf("Erro ao carregar o XML das aplicacoes -> %s\n", doc.ErrorDesc());

    }
/*
    if (doc.RootElement()->FirstChildElement("AdicionaFonema") != 0) {
        pt_nivel1 = doc.RootElement()->FirstChildElement("AdicionaFonema");
        atr = pt_nivel1->FirstAttribute();
        string operacao = atr->Value();
        cout << "Operacao: " << operacao << endl;
        string ladoCorpo;
        if (operacao.compare("AdicionaExpressaoFacial") != 0) {
            atr = atr->Next();
            ladoCorpo = atr->Value();
            cout << "Lado do Corpo: " << ladoCorpo << endl;
        }
        atr = atr->Next();
        string numeroOssos = atr->Value();
        cout << "Numero de Ossos: " << numeroOssos << endl;

        if (operacao.compare("AdicionaConfiguracaoMao") == 0) {

            string str;
            if (ladoCorpo.compare("direito") == 0) {
                str = "Dir";
            } else
                str = "Esq";
            string str1 = "../ScriptsPython/Libs/LibConfigMao";
            str1 += str;
            ofstream filestr(str1.c_str(), fstream::app);

            int ultimaConfig = getLastHandshapeNumber(ladoCorpo);

            cout << "Ultima Configuracao de Mao Registrada: " << ultimaConfig << endl;

            pt_nivel2 = pt_nivel1->FirstChildElement(); //BnDedo.1.R
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx1 = atr->Value();
            cout << locx1 << endl;
            atr = atr->Next();
            string locy1 = atr->Value();
            cout << locy1 << endl;
            atr = atr->Next();
            string locz1 = atr->Value();
            cout << locz1 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx1 = atr->Value();
            cout << rotx1 << endl;
            atr = atr->Next();
            string roty1 = atr->Value();
            cout << roty1 << endl;
            atr = atr->Next();
            string rotz1 = atr->Value();
            cout << rotz1 << endl;


            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.006
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx2 = atr->Value();
            cout << locx2 << endl;
            atr = atr->Next();
            string locy2 = atr->Value();
            cout << locy2 << endl;
            atr = atr->Next();
            string locz2 = atr->Value();
            cout << locz2 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx2 = atr->Value();
            cout << rotx2 << endl;
            atr = atr->Next();
            string roty2 = atr->Value();
            cout << roty2 << endl;
            atr = atr->Next();
            string rotz2 = atr->Value();
            cout << rotz2 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.005
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx3 = atr->Value();
            cout << locx3 << endl;
            atr = atr->Next();
            string locy3 = atr->Value();
            cout << locy3 << endl;
            atr = atr->Next();
            string locz3 = atr->Value();
            cout << locz3 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx3 = atr->Value();
            cout << rotx3 << endl;
            atr = atr->Next();
            string roty3 = atr->Value();
            cout << roty3 << endl;
            atr = atr->Next();
            string rotz3 = atr->Value();
            cout << rotz3 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.001
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx4 = atr->Value();
            cout << locx4 << endl;
            atr = atr->Next();
            string locy4 = atr->Value();
            cout << locy4 << endl;
            atr = atr->Next();
            string locz4 = atr->Value();
            cout << locz4 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx4 = atr->Value();
            cout << rotx4 << endl;
            atr = atr->Next();
            string roty4 = atr->Value();
            cout << roty4 << endl;
            atr = atr->Next();
            string rotz4 = atr->Value();
            cout << rotz4 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.008
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx5 = atr->Value();
            cout << locx5 << endl;
            atr = atr->Next();
            string locy5 = atr->Value();
            cout << locy5 << endl;
            atr = atr->Next();
            string locz5 = atr->Value();
            cout << locz5 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx5 = atr->Value();
            cout << rotx5 << endl;
            atr = atr->Next();
            string roty5 = atr->Value();
            cout << roty5 << endl;
            atr = atr->Next();
            string rotz5 = atr->Value();
            cout << rotz5 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.007
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx6 = atr->Value();
            cout << locx6 << endl;
            atr = atr->Next();
            string locy6 = atr->Value();
            cout << locy6 << endl;
            atr = atr->Next();
            string locz6 = atr->Value();
            cout << locz6 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx6 = atr->Value();
            cout << rotx6 << endl;
            atr = atr->Next();
            string roty6 = atr->Value();
            cout << roty6 << endl;
            atr = atr->Next();
            string rotz6 = atr->Value();
            cout << rotz6 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.002
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx7 = atr->Value();
            cout << locx7 << endl;
            atr = atr->Next();
            string locy7 = atr->Value();
            cout << locy7 << endl;
            atr = atr->Next();
            string locz7 = atr->Value();
            cout << locz7 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx7 = atr->Value();
            cout << rotx7 << endl;
            atr = atr->Next();
            string roty7 = atr->Value();
            cout << roty7 << endl;
            atr = atr->Next();
            string rotz7 = atr->Value();
            cout << rotz7 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.010
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx8 = atr->Value();
            cout << locx8 << endl;
            atr = atr->Next();
            string locy8 = atr->Value();
            cout << locy8 << endl;
            atr = atr->Next();
            string locz8 = atr->Value();
            cout << locz8 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx8 = atr->Value();
            cout << rotx8 << endl;
            atr = atr->Next();
            string roty8 = atr->Value();
            cout << roty8 << endl;
            atr = atr->Next();
            string rotz8 = atr->Value();
            cout << rotz8 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.009
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx9 = atr->Value();
            cout << locx9 << endl;
            atr = atr->Next();
            string locy9 = atr->Value();
            cout << locy9 << endl;
            atr = atr->Next();
            string locz9 = atr->Value();
            cout << locz9 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx9 = atr->Value();
            cout << rotx9 << endl;
            atr = atr->Next();
            string roty9 = atr->Value();
            cout << roty9 << endl;
            atr = atr->Next();
            string rotz9 = atr->Value();
            cout << rotz9 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.003
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx10 = atr->Value();
            cout << locx10 << endl;
            atr = atr->Next();
            string locy10 = atr->Value();
            cout << locy10 << endl;
            atr = atr->Next();
            string locz10 = atr->Value();
            cout << locz10 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx10 = atr->Value();
            cout << rotx10 << endl;
            atr = atr->Next();
            string roty10 = atr->Value();
            cout << roty10 << endl;
            atr = atr->Next();
            string rotz10 = atr->Value();
            cout << rotz10 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.012
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx11 = atr->Value();
            cout << locx11 << endl;
            atr = atr->Next();
            string locy11 = atr->Value();
            cout << locy11 << endl;
            atr = atr->Next();
            string locz11 = atr->Value();
            cout << locz11 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx11 = atr->Value();
            cout << rotx11 << endl;
            atr = atr->Next();
            string roty11 = atr->Value();
            cout << roty11 << endl;
            atr = atr->Next();
            string rotz11 = atr->Value();
            cout << rotz11 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.0011
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx12 = atr->Value();
            cout << locx12 << endl;
            atr = atr->Next();
            string locy12 = atr->Value();
            cout << locy12 << endl;
            atr = atr->Next();
            string locz12 = atr->Value();
            cout << locz12 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx12 = atr->Value();
            cout << rotx12 << endl;
            atr = atr->Next();
            string roty12 = atr->Value();
            cout << roty12 << endl;
            atr = atr->Next();
            string rotz12 = atr->Value();
            cout << rotz12 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.004
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx13 = atr->Value();
            cout << locx13 << endl;
            atr = atr->Next();
            string locy13 = atr->Value();
            cout << locy13 << endl;
            atr = atr->Next();
            string locz13 = atr->Value();
            cout << locz13 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx13 = atr->Value();
            cout << rotx13 << endl;
            atr = atr->Next();
            string roty13 = atr->Value();
            cout << roty13 << endl;
            atr = atr->Next();
            string rotz13 = atr->Value();
            cout << rotz13 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.014
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx14 = atr->Value();
            cout << locx14 << endl;
            atr = atr->Next();
            string locy14 = atr->Value();
            cout << locy14 << endl;
            atr = atr->Next();
            string locz14 = atr->Value();
            cout << locz14 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx14 = atr->Value();
            cout << rotx14 << endl;
            atr = atr->Next();
            string roty14 = atr->Value();
            cout << roty14 << endl;
            atr = atr->Next();
            string rotz14 = atr->Value();
            cout << rotz14 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnDedo.1.R.013
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx15 = atr->Value();
            cout << locx15 << endl;
            atr = atr->Next();
            string locy15 = atr->Value();
            cout << locy15 << endl;
            atr = atr->Next();
            string locz15 = atr->Value();
            cout << locz15 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx15 = atr->Value();
            cout << rotx15 << endl;
            atr = atr->Next();
            string roty15 = atr->Value();
            cout << roty15 << endl;
            atr = atr->Next();
            string rotz15 = atr->Value();
            cout << rotz15 << endl;

            //Escrever na Lib a nova configuracao de mao

            ultimaConfig++;
            string s = (std::string)"conf_" + convertInt(ultimaConfig);
            filestr << s << endl;

            string lado;

            if (ladoCorpo.compare("direito") == 0) {
                lado = "R";
            } else
                lado = "L";

            string s1 = "BnDedo.1." + lado + " " + (std::string)"Loc " + locx1 + (std::string)" " + locy1 + (std::string)" " + locz1 + (std::string)" Rot " + rotx1 + (std::string)" " + roty1 + (std::string)" " + rotz1;
            filestr << s1 << endl;

            string s2 = "BnDedo.1." + lado + ".006 " + (std::string)"Loc " + locx2 + (std::string)" " + locy2 + (std::string)" " + locz2 + (std::string)" Rot " + rotx2 + (std::string)" " + roty2 + (std::string)" " + rotz2;
            filestr << s2 << endl;

            string s3 = "BnDedo.1." + lado + ".005 " + (std::string)"Loc " + locx3 + (std::string)" " + locy3 + (std::string)" " + locz3 + (std::string)" Rot " + rotx3 + (std::string)" " + roty3 + (std::string)" " + rotz3;
            filestr << s3 << endl;

            string s4 = "BnDedo.1." + lado + ".001 " + (std::string)"Loc " + locx4 + (std::string)" " + locy4 + (std::string)" " + locz4 + (std::string)" Rot " + rotx4 + (std::string)" " + roty4 + (std::string)" " + rotz4;
            filestr << s4 << endl;

            string s5 = "BnDedo.1." + lado + ".008 " + (std::string)"Loc " + locx5 + (std::string)" " + locy5 + (std::string)" " + locz5 + (std::string)" Rot " + rotx5 + (std::string)" " + roty5 + (std::string)" " + rotz5;
            filestr << s5 << endl;

            string s6 = "BnDedo.1." + lado + ".007 " + (std::string)"Loc " + locx6 + (std::string)" " + locy6 + (std::string)" " + locz6 + (std::string)" Rot " + rotx6 + (std::string)" " + roty6 + (std::string)" " + rotz6;
            filestr << s6 << endl;

            string s7 = "BnDedo.1." + lado + ".002 " + (std::string)"Loc " + locx7 + (std::string)" " + locy7 + (std::string)" " + locz7 + (std::string)" Rot " + rotx7 + (std::string)" " + roty7 + (std::string)" " + rotz7;
            filestr << s7 << endl;

            string s8 = "BnDedo.1." + lado + ".010 " + (std::string)"Loc " + locx8 + (std::string)" " + locy8 + (std::string)" " + locz8 + (std::string)" Rot " + rotx8 + (std::string)" " + roty8 + (std::string)" " + rotz8;
            filestr << s8 << endl;

            string s9 = "BnDedo.1." + lado + ".009 " + (std::string)"Loc " + locx9 + (std::string)" " + locy9 + (std::string)" " + locz9 + (std::string)" Rot " + rotx9 + (std::string)" " + roty9 + (std::string)" " + rotz9;
            filestr << s9 << endl;

            string s10 = "BnDedo.1." + lado + ".003 " + (std::string)"Loc " + locx10 + (std::string)" " + locy10 + (std::string)" " + locz10 + (std::string)" Rot " + rotx10 + (std::string)" " + roty10 + (std::string)" " + rotz10;
            filestr << s10 << endl;

            string s11 = "BnDedo.1." + lado + ".012 " + (std::string)"Loc " + locx11 + (std::string)" " + locy11 + (std::string)" " + locz11 + (std::string)" Rot " + rotx11 + (std::string)" " + roty11 + (std::string)" " + rotz11;
            filestr << s11 << endl;

            string s12 = "BnDedo.1." + lado + ".011 " + (std::string)"Loc " + locx12 + (std::string)" " + locy12 + (std::string)" " + locz12 + (std::string)" Rot " + rotx12 + (std::string)" " + roty12 + (std::string)" " + rotz12;
            filestr << s12 << endl;

            string s13 = "BnDedo.1." + lado + ".004 " + (std::string)"Loc " + locx13 + (std::string)" " + locy13 + (std::string)" " + locz13 + (std::string)" Rot " + rotx13 + (std::string)" " + roty13 + (std::string)" " + rotz13;
            filestr << s13 << endl;

            string s14 = "BnDedo.1." + lado + ".014 " + (std::string)"Loc " + locx14 + (std::string)" " + locy14 + (std::string)" " + locz14 + (std::string)" Rot " + rotx14 + (std::string)" " + roty14 + (std::string)" " + rotz14;
            filestr << s14 << endl;

            string s15 = "BnDedo.1." + lado + ".013 " + (std::string)"Loc " + locx15 + (std::string)" " + locy15 + (std::string)" " + locz15 + (std::string)" Rot " + rotx15 + (std::string)" " + roty15 + (std::string)" " + rotz15;
            filestr << s15 << endl;

            filestr.close(); //close file
            assert(!filestr.fail());

        }
        if (operacao.compare("AdicionaOrientacaoMao") == 0) {

            string str2;
            if (ladoCorpo.compare("direito") == 0) {

                str2 = "Dir";
            } else
                str2 = "Esq";
            string str3 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibOrientacao";
            str3 += str2;
            ofstream filestr(str3.c_str(), fstream::app);


            int ultimaConfig = getLastOrientationHandNumber(ladoCorpo);

            cout << "Ultima Orientacao de Mao Registrada: " << ultimaConfig << endl;

            pt_nivel2 = pt_nivel1->FirstChildElement(); //BnMao.R 
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx1 = atr->Value();
            cout << locx1 << endl;
            atr = atr->Next();
            string locy1 = atr->Value();
            cout << locy1 << endl;
            atr = atr->Next();
            string locz1 = atr->Value();
            cout << locz1 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx1 = atr->Value();
            cout << rotx1 << endl;
            atr = atr->Next();
            string roty1 = atr->Value();
            cout << roty1 << endl;
            atr = atr->Next();
            string rotz1 = atr->Value();
            cout << rotz1 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnAntBraco.R.001
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx2 = atr->Value();
            cout << locx2 << endl;
            atr = atr->Next();
            string locy2 = atr->Value();
            cout << locy2 << endl;
            atr = atr->Next();
            string locz2 = atr->Value();
            cout << locz2 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx2 = atr->Value();
            cout << rotx2 << endl;
            atr = atr->Next();
            string roty2 = atr->Value();
            cout << roty2 << endl;
            atr = atr->Next();
            string rotz2 = atr->Value();
            cout << rotz2 << endl;

            ultimaConfig++;
            string s = (std::string)"Ori_" + convertInt(ultimaConfig);
            filestr << s << endl;

            string lado;

            if (ladoCorpo.compare("direito") == 0) {
                lado = "R";
            } else
                lado = "L";

            string s1 = "BnMao." + lado + " " + (std::string)"Loc " + locx1 + (std::string)" " + locy1 + (std::string)" " + locz1 + (std::string)" Rot " + rotx1 + (std::string)" " + roty1 + (std::string)" " + rotz1;
            filestr << s1 << endl;

            string s2 = "BnAntBraco." + lado + ".001" + (std::string)"Loc " + locx2 + (std::string)" " + locy2 + (std::string)" " + locz2 + (std::string)" Rot " + rotx2 + (std::string)" " + roty2 + (std::string)" " + rotz2;
            filestr << s2 << endl;

            filestr.close(); //close file
            assert(!filestr.fail());


        }
        if (operacao.compare("AdicionaPontoArticulacao") == 0) {
            string str2;
            if (ladoCorpo.compare("direito") == 0) {
                str2 = "Dir";
            } else
                str2 = "Esq";
            string str3 = "/usr/share/WikiLIBRAS/server/ScriptsPython/Libs/LibPontoArticulacao";
            str3 += str2;
            ofstream filestr(str3.c_str(), fstream::app);


            int ultimaConfig = getLastLocationPointNumber(ladoCorpo);

            cout << "Ultimo Ponto de Articulação Registrado: " << ultimaConfig << endl;

            pt_nivel2 = pt_nivel1->FirstChildElement(); //ik_FK.R
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx1 = atr->Value();
            cout << locx1 << endl;
            atr = atr->Next();
            string locy1 = atr->Value();
            cout << locy1 << endl;
            atr = atr->Next();
            string locz1 = atr->Value();
            cout << locz1 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx1 = atr->Value();
            cout << rotx1 << endl;
            atr = atr->Next();
            string roty1 = atr->Value();
            cout << roty1 << endl;
            atr = atr->Next();
            string rotz1 = atr->Value();
            cout << rotz1 << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //BnPolyV.R
            pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
            atr = pt_nivel3->FirstAttribute();
            string locx2 = atr->Value();
            cout << locx2 << endl;
            atr = atr->Next();
            string locy2 = atr->Value();
            cout << locy2 << endl;
            atr = atr->Next();
            string locz2 = atr->Value();
            cout << locz2 << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
            atr = pt_nivel3->FirstAttribute();
            string rotx2 = atr->Value();
            cout << rotx2 << endl;
            atr = atr->Next();
            string roty2 = atr->Value();
            cout << roty2 << endl;
            atr = atr->Next();
            string rotz2 = atr->Value();
            cout << rotz2 << endl;

            ultimaConfig++;
            string s = (std::string)"Pa_" + convertInt(ultimaConfig);
            filestr << s << endl;

            string lado;

            if (ladoCorpo.compare("direito") == 0) {
                lado = "R";
            } else
                lado = "L";

            string s1 = "BnMao." + lado + " " + (std::string)"Loc " + locx1 + (std::string)" " + locy1 + (std::string)" " + locz1 + (std::string)" Rot " + rotx1 + (std::string)" " + roty1 + (std::string)" " + rotz1;
            filestr << s1 << endl;

            string s2 = "BnAntBraco." + lado + ".001" + (std::string)"Loc " + locx2 + (std::string)" " + locy2 + (std::string)" " + locz2 + (std::string)" Rot " + rotx2 + (std::string)" " + roty2 + (std::string)" " + rotz2;
            filestr << s2 << endl;

            filestr.close(); //close file
            assert(!filestr.fail());
        }
        if (operacao.compare("AdicionaExpressaoFacial") == 0) {

            string str3 = "../ScriptsPython/Libs/testeExp";

            ofstream filestr(str3.c_str(), fstream::app);

            int ultimaConfig = getLastFacialExpressionNumber();

            cout << "Ultima Expressao Facial Registrada " << ultimaConfig << endl;

            ultimaConfig++;
            string s = (std::string)"Exp_" + convertInt(ultimaConfig) + " " + numeroOssos;
            filestr << s << endl;

            int result = atoi(numeroOssos.c_str());
            //cout << "numero rodadas for: "<< result << endl;


            for (int i = 0; i < result; i++) {
                if (i == 0) {
                    //cout << "pt2 = pt1-primeiro" << endl;
                    pt_nivel2 = pt_nivel1->FirstChildElement(); //Name Node
                } else {
                    //cout << "pt2 = pt2-proximo" << endl;
                    pt_nivel2 = pt_nivel2->NextSiblingElement(); //Name Node			
                }
                cout << pt_nivel2->ValueStr() << endl;
                string nomeBone = pt_nivel2->ValueStr();
                pt_nivel3 = pt_nivel2->FirstChildElement(); //loc
                atr = pt_nivel3->FirstAttribute();
                string locx1 = atr->Value();
                cout << locx1 << endl;
                atr = atr->Next();
                string locy1 = atr->Value();
                cout << locy1 << endl;
                atr = atr->Next();
                string locz1 = atr->Value();
                cout << locz1 << endl;

                pt_nivel3 = pt_nivel3->NextSiblingElement(); //Rot
                atr = pt_nivel3->FirstAttribute();
                string rotx1 = atr->Value();
                cout << rotx1 << endl;
                atr = atr->Next();
                string roty1 = atr->Value();
                cout << roty1 << endl;
                atr = atr->Next();
                string rotz1 = atr->Value();
                cout << rotz1 << endl;

                string s1 = nomeBone + " " + (std::string)"Loc " + locx1 + (std::string)" " + locy1 + (std::string)" " + locz1 + (std::string)" Rot " + rotx1 + (std::string)" " + roty1 + (std::string)" " + rotz1;
                filestr << s1 << endl;

            }

        }
    }
*/
    if (doc.RootElement()->FirstChildElement("nomeDoSinal") != 0) {
        pt_nivel1 = doc.RootElement()->FirstChildElement("nomeDoSinal");
        nomeDoSinal = pt_nivel1->GetText();

        nomeParamDir = nomeDoSinal + string("Dir");
        nomeParamEsq = nomeDoSinal + string("Esq");

        pt_nivel1 = pt_nivel1->NextSiblingElement();
        atr = pt_nivel1->FirstAttribute();
        tipoDoMovimentoDir = atr->Value();


        cout << tipoDoMovimentoDir << endl;
        /*
        if (tipoDoMovimento.compare("Helicoidal") == 0) {
            cout << "Movimento mao direita é " + tipoDoMovimento << endl;
            movimentoMaoDireita = "Helicoidal";

            atr = atr->Next();
            string tamanhoDoRaio = atr->Value(); //Grande, Medio ou Pequeno

            atr = atr->Next();
            string sentidoDoMovimento = atr->Value(); // Horario ou Anti-Horario

            atr = atr->Next();
            string direcao = atr->Value(); //para-direita, para-esquerda, para-frente, para-tras, para-cima, para-baixo

            pt_nivel2 = pt_nivel1->FirstChildElement(); //Configuracao da mao direita

            pt_nivel3 = pt_nivel2->FirstChildElement(); //Configuracao dos dedos da mao direita
            configDedos = pt_nivel3->GetText();
            string tempConfDedosInicial = "conf_" + configDedos;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Lado da mao
            lado = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Orientacao da mao direita
            orientacaoMao = pt_nivel3->GetText();

            string tempOriMaoInicial = oriMao->retornaStringCorrespondenteAOrientacao(orientacaoMao);

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //Ponto de Articulacao mao direita

            pt_nivel3 = pt_nivel2->FirstChildElement();
            subdivisao = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            localizacao = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            tipoContato = pt_nivel3->GetText();

            string pontoArticulacaoInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao, tipoContato);

            ofstream outDir(nomeParamDir.c_str());
            outDir << tempConfDedosInicial << endl;
            outDir << tempOriMaoInicial << endl;
            outDir << pontoArticulacaoInicial << endl;
            outDir << sentidoDoMovimento << endl;
            outDir << direcao << endl;
            outDir << tamanhoDoRaio << endl;
            outDir << nomeDoSinal << endl;

            outDir.close();
        }
         */
        if (tipoDoMovimentoDir.compare("semicircular") == 0) {
            cout << "Movimento mao direita é " + tipoDoMovimentoDir << endl;
            //tipoDoMovimentoDir = "SemiCircular";

            atr = atr->Next();
            tamanhoRaioDir = atr->Value();

            atr = atr->Next();
            sentidoMovimentoDir = atr->Value();

            atr = atr->Next();
            string direcaoDir = atr->Value();

            atr = atr->Next();
            flagRepeticaoDir = atr->Value();

            if (flagRepeticaoDir.compare("com-repeticao") == 0) {
                // avancar ou retroceder
                atr = atr->Next();
                tipoRepeticaoDir = atr->Value();
            }

            //para-direita, para-esquerda, para-frente, para-tras, para-cima, para-baixo
            atr = atr->Next();
            direcaoMovimentoDir = atr->Value();

            atr = atr->Next();
            maoUtilizada = atr->Value();

            /*if (maoUtilizada.compare("duas") == 0) {
                atr = atr->Next();
                sincronismo = atr->Value();
            }*/

	    sincronismo = "sincrono";
            pt_nivel2 = pt_nivel1->FirstChildElement();
            pt_nivel3 = pt_nivel2->FirstChildElement();

            string tempDir = pt_nivel3->GetText();
            configDedosDir = "conf_" + tempDir;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosDir = atr->Value();
            orientacaoMaoDir = oriMao->getOrientacaoPalmaMao(orientacaoPalmaDir, sentidoPalmaDir, sentidoPontaDedosDir);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
           // estadoPontoArticulacaoDir = atr->Value();
            //atr = atr->Next();
            subdivisaoDir = atr->Value();
            atr = atr->Next();
            localizacaoDir = atr->Value();
            string pontoArticulacaoDirInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoDir, localizacaoDir);
	    tipoRepeticaoDir = "avancar";

            ofstream outDir(nomeParamDir.c_str());
            outDir << configDedosDir << endl;
            outDir << orientacaoMaoDir << endl;
            outDir << pontoArticulacaoDirInicial << endl;
            outDir << tamanhoRaioDir << endl;
            outDir << sentidoMovimentoDir << endl;
	    outDir << direcaoDir << endl; //Orientacao do Movimento. (para-frente , para-dentro, para-cima)
            outDir << direcaoMovimentoDir << endl;
            outDir << flagRepeticaoDir << endl;


            if (flagRepeticaoDir.compare("com-repeticao") == 0) {
                outDir << tipoRepeticaoDir << endl;
            }
	    cout << "mao utilizada: " << maoUtilizada << endl;
	    outDir << maoUtilizada << endl;

            if (maoUtilizada.compare("duas") == 0) {
                outDir << sincronismo << endl;
            }
            outDir << nomeDoSinal << endl;
            outDir.close();
        }

        if (tipoDoMovimentoDir.compare("circular") == 0) {
            cout << "Movimento mao direita é " + tipoDoMovimentoDir << endl;

            //movimentoMaoDireita = "Circular";

            atr = atr->Next();
            tamanhoRaioDir = atr->Value();

            atr = atr->Next();
            sentidoMovimentoDir = atr->Value();

            atr = atr->Next();
            orientacaoMovimentoDir = atr->Value();

            atr = atr->Next();
            flagRepeticaoDir = atr->Value();


	    atr = atr->Next();
	    maoUtilizada = atr->Value();
/*
	    if (maoUtilizada.compare("duas") == 0) {
                atr = atr->Next();
                sincronismo = atr->Value();

            }            
*/
            pt_nivel2 = pt_nivel1->FirstChildElement();
            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempDir = pt_nivel3->GetText();
            configDedosDir = "conf_" + tempDir;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosDir = atr->Value();
            orientacaoMaoDir = oriMao->getOrientacaoPalmaMao(orientacaoPalmaDir, sentidoPalmaDir, sentidoPontaDedosDir);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            //estadoPontoArticulacaoDir = atr->Value();
            //atr = atr->Next();
            subdivisaoDir = atr->Value();
            atr = atr->Next();
            localizacaoDir = atr->Value();
	    pontoArticulacaoDirInicial = pa->getPontoArticulacaoCorreto(subdivisaoDir, localizacaoDir, orientacaoMaoDir);
//            pontoArticulacaoDirInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoDir, localizacaoDir);

            ofstream outDir(nomeParamDir.c_str());
            outDir << configDedosDir << endl;
            outDir << orientacaoMaoDir << endl;
            outDir << pontoArticulacaoDirInicial << endl;
            outDir << tamanhoRaioDir << endl;
            outDir << sentidoMovimentoDir << endl;
            outDir << orientacaoMovimentoDir << endl;
            outDir << flagRepeticaoDir << endl;
	    outDir << maoUtilizada << endl;

	    if (maoUtilizada.compare("duas") == 0) {
            	outDir << sincronismo << endl;
            	outDir << nomeDoSinal << endl;	    	
            }else{
            	outDir << nomeDoSinal << endl;	 	    	
	    }




            outDir.close();
        }

        if (tipoDoMovimentoDir.compare("retilineo") == 0) {


            //movimentoMaoDireita = "Retilineo";

            cout << "****************************** RETILÍNEO ******************************" << endl;

            atr = atr->Next();
            flagRepeticaoDir = atr->Value();
	    cout << "Flag Repeticao Dir "<< flagRepeticaoDir <<endl;

            atr = atr->Next();
            maoUtilizada = atr->Value();
	    cout << "Maos Utilizadas " << maoUtilizada << endl;
/*
            if (maoUtilizada.compare("duas") == 0) {
                atr = atr->Next();
                sincronismo = atr->Value();

            }
*/
            pt_nivel2 = pt_nivel1->FirstChildElement();
            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempDir = pt_nivel3->GetText();

            string configDedosDirInicial = "conf_" + tempDir;
	    cout << "Configuracao de Mao Inicial Dir " << configDedosDirInicial << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //fui para o campo orientacao da mao inicial
            atr = pt_nivel3->FirstAttribute();
            string orientacaoDir = atr->Value();
            atr = atr->Next();
            string sentidoDir = atr->Value();
            atr = atr->Next();
            string orientacaoPontaDedosDir = atr->Value();

            cout << orientacaoDir << endl;
            cout << sentidoDir << endl;
            cout << orientacaoPontaDedosDir << endl;

            string OriMaoInicial = oriMao->getOrientacaoPalmaMao(orientacaoDir, sentidoDir, orientacaoPontaDedosDir);
            cout << OriMaoInicial << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //Configuracao da mao direita estado final
            pt_nivel3 = pt_nivel2->FirstChildElement(); //Configuracao dos dedos da mao direita
            string tempConfDedosFinal = pt_nivel3->GetText();
	   
            string configDedosDirFinal = "conf_" + tempConfDedosFinal;
            cout << configDedosDirFinal << endl;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Orientacao da mao final
            atr = pt_nivel3->FirstAttribute();
            orientacaoDir = atr->Value();
            atr = atr->Next();
            sentidoDir = atr->Value();
            atr = atr->Next();
            orientacaoPontaDedosDir = atr->Value();

            cout << orientacaoDir << endl;
            cout << sentidoDir << endl;
            cout << orientacaoPontaDedosDir << endl;
            string OriMaoFinal = oriMao->getOrientacaoPalmaMao(orientacaoDir, sentidoDir, orientacaoPontaDedosDir);
            cout << OriMaoFinal << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //Ponto de Articulacao mao direita estado inicial
            atr = pt_nivel2->FirstAttribute();
            string estadoPontoArticulacao = atr->Value();
            atr = atr->Next();
            string subdivisao = atr->Value();
            cout << subdivisao << endl;
            atr = atr->Next();
            string localizacao = atr->Value();
            cout << localizacao << endl;
            string pontoArticulacaoInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao);
            cout << pontoArticulacaoInicial << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //Ponto de articulacao final da mao direita
            atr = pt_nivel2->FirstAttribute();
            estadoPontoArticulacao = atr->Value();
            atr = atr->Next();
            subdivisao = atr->Value();
            cout << subdivisao << endl;
            atr = atr->Next();
            localizacao = atr->Value();
            cout << localizacao << endl;
            string pontoArticulacaoFinal = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao);
            cout << pontoArticulacaoFinal << endl;

            ofstream outDir(nomeParamDir.c_str());
            //outDir << 1 << endl;
            outDir << configDedosDirInicial << endl;
            outDir << OriMaoInicial << endl;
            outDir << pontoArticulacaoInicial << endl;

            //outDir << 20 << endl;
            outDir << configDedosDirFinal << endl;
            outDir << OriMaoFinal << endl;
            outDir << pontoArticulacaoFinal << endl;
            outDir << flagRepeticaoDir << endl;
	    outDir << maoUtilizada << endl;
            if (maoUtilizada.compare("duas") == 0) {
		cout << "aqui";
                outDir << "sincrono" << endl; //GAMBIARRA
                outDir << nomeDoSinal << endl;
            }
            if (maoUtilizada.compare("uma") == 0) {
                outDir << nomeDoSinal << endl;
            }
            outDir.close();

            //if (flagRepeticaoDir.compare("com-repeticao") == 0) {
            //  outDir << 40 << endl;
            //outDir << pontoArticulacaoInicial << endl;
            //outDir << OriMaoInicial << endl;
            //outDir << configDedosDirInicial << endl;

            // outDir << 60 << endl;
            //outDir << pontoArticulacaoFinal << endl;
            //outDir << OriMaoFinal << endl;
            //outDir << OriMaoFinal << endl;
            //outDir << nomeDoSinal << endl;
            //outDir.close();
            //} else {
            //outDir << nomeDoSinal << endl;
            //outDir.close();
            // }
        }

        if (tipoDoMovimentoDir.compare("pontual") == 0) {

            atr = atr->Next();
            maoUtilizada = atr->Value();
	    cout << "Maos Utilizadas " << maoUtilizada << endl;

           pt_nivel2 = pt_nivel1->FirstChildElement();
            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempDir = pt_nivel3->GetText();
            configDedosDir = "conf_" + tempDir;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPalmaDir = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosDir = atr->Value();
            orientacaoMaoDir = oriMao->getOrientacaoPalmaMao(orientacaoPalmaDir, sentidoPalmaDir, sentidoPontaDedosDir);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            //estadoPontoArticulacaoDir = atr->Value();
            //atr = atr->Next();
            subdivisaoDir = atr->Value();
            atr = atr->Next();
            localizacaoDir = atr->Value();
	    cout << "***********************ORIENTACAO DE MAO ESCOLHIDA: " << orientacaoMaoDir << endl;
	    pontoArticulacaoDirInicial = pa->getPontoArticulacaoCorreto(subdivisaoDir, localizacaoDir, orientacaoMaoDir);
	    cout << " ***********************PONTO DE ARTICULACAO ESCOLHIDO: " << pontoArticulacaoDirInicial << endl;
            //pontoArticulacaoDirInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoDir, localizacaoDir);

            ofstream outDir(nomeParamDir.c_str());

	    outDir << configDedosDir << endl;
	    outDir << orientacaoMaoDir << endl;
 	    outDir << pontoArticulacaoDirInicial << endl;
	    outDir << maoUtilizada << endl;
	    outDir << nomeDoSinal << endl;
	    outDir.close();
	}


        pt_nivel1 = pt_nivel1->NextSiblingElement();
        atr = pt_nivel1->FirstAttribute();
        tipoDoMovimentoEsq = atr->Value();


        /*
        if (tipoDoMovimento.compare("helicoidal") == 0) {
            cout << "Movimento mao esquerda é " + tipoDoMovimento << endl;

            movimentoMaoDireita = "Helicoidal";

            atr = atr->Next();
            string tamanhoDoRaio = atr->Value(); //Grande, Medio ou Pequeno

            atr = atr->Next();
            string sentidoDoMovimento = atr->Value();

            atr = atr->Next();
            string direcao = atr->Value(); //para-direita, para-esquerda, para-frente, para-tras, para-cima, para-baixo

            pt_nivel2 = pt_nivel1->FirstChildElement(); //Configuracao da mao esquerda

            pt_nivel3 = pt_nivel2->FirstChildElement(); //Configuracao dos dedos da mao esquerda
            string configDedosInicialEsq = pt_nivel3->GetText();

            string tempConfDedosInicialEsq = "conf_" + configDedosInicialEsq;

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Lado da mao
            lado = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement(); //Orientacao da mao esquerda
            string orientacaoMaoInicialEsq = pt_nivel3->GetText();

            string tempOriMaoInicialEsq = oriMao->retornaStringCorrespondenteAOrientacao(orientacaoMaoInicialEsq);

            pt_nivel2 = pt_nivel2->NextSiblingElement(); //Ponto de Articulacao mao esquerda estado inicial

            pt_nivel3 = pt_nivel2->FirstChildElement();
            subdivisao = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            localizacao = pt_nivel3->GetText();

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            tipoContato = pt_nivel3->GetText();

            string pontoArticulacaoInicialEsq = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao, tipoContato);

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();

            cout << expressaoFacial << endl;
            facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);

            ofstream outEsq(nomeParamEsq.c_str());

            outEsq << tempConfDedosInicialEsq << endl;
            outEsq << tempOriMaoInicialEsq << endl;
            outEsq << pontoArticulacaoInicialEsq << endl;
            outEsq << sentidoDoMovimento << endl;
            outEsq << direcao << endl;
            outEsq << tamanhoDoRaio << endl;
            outEsq << facial << endl;

            outEsq.close();
        }
         **/
        if (tipoDoMovimentoEsq.compare("semicircular") == 0) {

            cout << "Movimento mao esquerda é " + tipoDoMovimentoEsq << endl;

            //movimentoMaoDireita = "SemiCircular";

            atr = atr->Next();
            tamanhoRaioEsq = atr->Value();

            atr = atr->Next();
            sentidoMovimentoEsq = atr->Value();

	    string direcaoMovimentoEsq = atr->Value();

            atr = atr->Next();
            flagRepeticaoEsq = atr->Value();

	/*
            if (flagRepeticaoEsq.compare("com-repeticao") == 0) {
                atr = atr->Next();
                tipoRepeticaoEsq = atr->Value();
            }
*/
	    tipoRepeticaoEsq = "avancar";

            atr = atr->Next();
            direcaoMovimentoEsq = atr->Value(); //para-direita, para-esquerda, para-frente, para-tras, para-cima, para-baixo

            pt_nivel2 = pt_nivel1->FirstChildElement();

            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempEsq = pt_nivel3->GetText();
            configDedosEsq = "conf_" + tempEsq;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoMovimentoEsq = atr->Value();
            atr = atr->Next();
            sentidoMovimentoEsq = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosEsq = atr->Value();
            orientacaoMaoEsq = oriMao->getOrientacaoPalmaMao(orientacaoMovimentoEsq, sentidoMovimentoEsq, sentidoPontaDedosEsq);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            estadoPontoArticulacaoEsq = atr->Value();
            atr = atr->Next();
            subdivisaoEsq = atr->Value();
            atr = atr->Next();
            localizacaoEsq = atr->Value();
            pontoArticulacaoEsqInicial = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoEsq, localizacaoEsq);

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();

            string facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);

            ofstream outEsq(nomeParamEsq.c_str());

            outEsq << configDedosEsq << endl;
            outEsq << orientacaoMaoEsq << endl;
            outEsq << tamanhoRaioEsq << endl;
            outEsq << sentidoMovimentoEsq << endl;
            outEsq << flagRepeticaoEsq << endl;
            if (flagRepeticaoEsq.compare("com-repeticao") == 0) {
                outEsq << tipoRepeticaoEsq << endl;
            }
            outEsq << direcaoMovimentoEsq << endl;
            outEsq << pontoArticulacaoEsqInicial << endl;
            outEsq << facial << endl;

            outEsq.close();
        }

        if (tipoDoMovimentoEsq.compare("circular") == 0) {
            cout << "Movimento da mao esquerda eh " + tipoDoMovimentoEsq << endl;

            atr = atr->Next();
            tamanhoRaioEsq = atr->Value();

            atr = atr->Next();
            sentidoMovimentoEsq = atr->Value();

            atr = atr->Next();
            orientacaoMovimentoEsq = atr->Value();

            atr = atr->Next();
            flagRepeticaoEsq = atr->Value();

            pt_nivel2 = pt_nivel1->FirstChildElement();

            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempDir = pt_nivel3->GetText();
            configDedosEsq = "conf_" + tempDir;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoPalmaEsq = atr->Value();
            atr = atr->Next();
            sentidoPalmaEsq = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosEsq = atr->Value();
            orientacaoMaoEsq = oriMao->getOrientacaoPalmaMao(orientacaoPalmaEsq, sentidoPalmaEsq, sentidoPontaDedosEsq);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            //estadoPontoArticulacaoEsq = atr->Value();
            //atr = atr->Next();
            subdivisaoEsq = atr->Value();
            atr = atr->Next();
            localizacaoEsq = atr->Value();
            string pontoArticulacaoInicialEsq = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoEsq, localizacaoEsq);

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();
            string facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);

            ofstream outEsq(nomeParamEsq.c_str());

            outEsq << configDedosEsq << endl;
            outEsq << orientacaoMaoEsq << endl;
            outEsq << pontoArticulacaoInicialEsq << endl;
            outEsq << tamanhoRaioEsq << endl;
            outEsq << sentidoMovimentoEsq << endl;
            outEsq << orientacaoMovimentoEsq << endl;
            outEsq << flagRepeticaoEsq << endl;
            outEsq << facial << endl;

        }

        if (tipoDoMovimentoEsq.compare("retilineo") == 0) {

            atr = atr->Next();
            flagRepeticaoEsq = atr->Value();

            pt_nivel2 = pt_nivel1->FirstChildElement();
            atr = pt_nivel2->FirstAttribute();

            pt_nivel3 = pt_nivel2->FirstChildElement();
            string configDedosInicialEsq = pt_nivel3->GetText();
            string tempConfDedosInicialEsq = "conf_" + configDedosInicialEsq;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();


            string orientacaoMaoInicialEsq = atr->Value();
            atr = atr->Next();
            string sentidoEsq = atr->Value();
            atr = atr->Next();
            string orientacaoPontaDedosEsq = atr->Value();

            string tempOriMaoInicialEsq = oriMao->getOrientacaoPalmaMao(orientacaoMaoInicialEsq, sentidoEsq, orientacaoPontaDedosEsq);


            pt_nivel2 = pt_nivel2->NextSiblingElement();
            pt_nivel3 = pt_nivel2->FirstChildElement();
            string configDedosFinalEsq = pt_nivel3->GetText();
            string tempConfDedosFinalEsq = "conf_" + configDedosFinalEsq;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            string orientacaoMaoFinalEsq = atr->Value();
            atr = atr->Next();
            sentidoEsq = atr->Value();
            atr = atr->Next();
            orientacaoPontaDedosEsq = atr->Value();
            string tempOriMaoFinalEsq = oriMao->getOrientacaoPalmaMao(orientacaoMaoFinalEsq, sentidoEsq, orientacaoPontaDedosEsq);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            string estadoPontoArticulacao = atr->Value();
            atr = atr->Next();
            string subdivisao = atr->Value();
            cout << subdivisao << endl;
            atr = atr->Next();
            string localizacao = atr->Value();
            cout << localizacao << endl;
            string pontoArticulacaoInicialEsq = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao);
            cout << pontoArticulacaoInicialEsq << endl;

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            estadoPontoArticulacao = atr->Value();
            atr = atr->Next();
            subdivisao = atr->Value();
            cout << subdivisao << endl;
            atr = atr->Next();
            localizacao = atr->Value();
            cout << localizacao << endl;
            string pontoArticulacaoFinalEsq = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisao, localizacao);
            cout << pontoArticulacaoFinalEsq << endl;

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();
            string facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);
            cout << "Existe Movimento da Mão Esquerda" << endl;

            ofstream outEsq(nomeParamEsq.c_str());
            outEsq << tempConfDedosInicialEsq << endl;
            outEsq << tempOriMaoInicialEsq << endl;
            outEsq << pontoArticulacaoInicialEsq << endl;

            outEsq << tempConfDedosFinalEsq << endl;
            outEsq << tempOriMaoFinalEsq << endl;
            outEsq << pontoArticulacaoFinalEsq << endl;

            outEsq << flagRepeticaoEsq << endl;

            outEsq << facial << endl;
            outEsq.close();

        }

        if (tipoDoMovimentoEsq.compare("pontual") == 0) {

            cout << "****************************** PONTUAL ******************************" << endl;
            pt_nivel2 = pt_nivel1->FirstChildElement();

            pt_nivel3 = pt_nivel2->FirstChildElement();
            string tempDir = pt_nivel3->GetText();
            configDedosEsq = "conf_" + tempDir;

            pt_nivel3 = pt_nivel3->NextSiblingElement();
            atr = pt_nivel3->FirstAttribute();
            orientacaoPalmaEsq = atr->Value();
            atr = atr->Next();
            sentidoPalmaEsq = atr->Value();
            atr = atr->Next();
            sentidoPontaDedosEsq = atr->Value();
            orientacaoMaoEsq = oriMao->getOrientacaoPalmaMao(orientacaoPalmaEsq, sentidoPalmaEsq, sentidoPontaDedosEsq);

            pt_nivel2 = pt_nivel2->NextSiblingElement();
            atr = pt_nivel2->FirstAttribute();
            estadoPontoArticulacaoEsq = atr->Value();
            atr = atr->Next();
            subdivisaoEsq = atr->Value();
            atr = atr->Next();
            localizacaoEsq = atr->Value();
            string pontoArticulacaoInicialEsq = pa->retornaStringCorrespondenteAoPontoArticulacao(subdivisaoEsq, localizacaoEsq);

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();
            string facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);

            ofstream outEsq(nomeParamEsq.c_str());

            outEsq << configDedosEsq << endl;
            outEsq << orientacaoMaoEsq << endl;
            outEsq << pontoArticulacaoInicialEsq << endl;          
            outEsq << facial << endl;
	}


        if (tipoDoMovimentoEsq.compare("nenhum") == 0) {
            cout << "Nao existe movimento com a mao esquerda" << endl;

            pt_nivel1 = pt_nivel1->NextSiblingElement();
            expressaoFacial = pt_nivel1->GetText();
	    cout << "expressao facial: " << expressaoFacial << endl;

            string facial = expFacial->retornaStringCorrespondenteAExpressaoFacial(expressaoFacial);

            cout << "ExpressaoFacial " << "[" << facial << "]" << "[" << expressaoFacial << "]" << endl;

            ofstream outEsq(nomeParamEsq.c_str());
            outEsq << "Nenhum" << endl;
            outEsq << facial << endl;
            outEsq.close();
        }

        cout << "Parametros Dir e Esq criados" << endl;
	//ATENCAO AQUI!!!!!!!! lembrar de adicionar o alias no linux com o seguinte comando: alias mv='mv -f'

	cout << "/var/www/wikilibras/" + nomeParamDir << endl;
 
        string str1 = "sudo mv " + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/";
        string str2 = "sudo mv " + nomeParamEsq + " /usr/share/WikiLIBRAS/server/ScriptsPython/";

        system(str1.c_str());
        system(str2.c_str());


        if ((tipoDoMovimentoDir.compare("retilineo") == 0)) {
            cout << "Rendering Straight Movement" << endl;
            string str3 = "blender -b /usr/share/WikiLIBRAS/server/ScriptsPython/mulher05_iK_14_05.blend -P /usr/share/WikiLIBRAS/server/ScriptsPython/MovRetilineo.py /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamEsq;
            system(str3.c_str());
        }

        if (tipoDoMovimentoDir.compare("circular") == 0) {
	    //ofstream outum("LOG");
	    //outum << "Circular" << endl;

            cout << "Rendering Circle Movement" << endl;
            string str4 = "cd /usr/share/WikiLIBRAS/server/ScriptsPython/";
	    system(str4.c_str());

	    string ss = "blender -b /usr/share/WikiLIBRAS/server/ScriptsPython/mulher05_iK_14_05.blend -P /usr/share/WikiLIBRAS/server/ScriptsPython/MovCircular.py /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamEsq;
	    system(ss.c_str());
	    
 	    
        }
        if (tipoDoMovimentoDir.compare("semicircular") == 0) {

            cout << "Rendering Round Movement" << endl;
            string str5 = "blender -b /usr/share/WikiLIBRAS/server/ScriptsPython/mulher05_iK_14_05.blend -P /usr/share/WikiLIBRAS/server/ScriptsPython/MovSemiCircular.py /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamEsq;
            system(str5.c_str());
        }

        if (tipoDoMovimentoDir.compare("helicoidal") == 0) {

            cout << "Rendering Spiral Movement" << endl;
            string str5 = "blender -b /usr/share/WikiLIBRAS/server/ScriptsPython/mulher05_iK_14_05.blend -P /usr/share/WikiLIBRAS/server/ScriptsPython/MovHelicoidal.py /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamEsq;
            system(str5.c_str());
        }

        if (tipoDoMovimentoDir.compare("pontual") == 0) {

            cout << "Static Movement" << endl;
            string str6 = "blender -b /usr/share/WikiLIBRAS/server/ScriptsPython/mulher05_iK_14_05.blend -P /usr/share/WikiLIBRAS/server/ScriptsPython/movPontual.py /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamDir + " /usr/share/WikiLIBRAS/server/ScriptsPython/" + nomeParamEsq;
            system(str6.c_str());
        }
	
 //       this->flagEndOfRead = true;
    }
}

//void ReadXml::Run() {

//    Leitura();

//}

