#include "pontoArticulacao.h"
#include <string>
#include <iostream>
#include <string.h>

using namespace std;

PontoArticulacao::PontoArticulacao() {
}

string PontoArticulacao::getPontoArticulacaoCorreto(string subdivisao, string localizacao, string orientacaoMaoCheck){

/*
Caso a referencia seja a ponta dos dedos e a orientação da mão seja "paralelo-ao-corpo/para-tras/para-cima(Ori_1)", devo utilizar os seguintes pontos de articulaçao para a subdivisao cabeça:
Pa_6 Boca
distanciamedia
Pa_7 Boca
distante
Pa_8 Boca
Caso a orientação da mão seja "paralelo-ao-corpo/para-dentro/para-cima(Ori_2)", devo utilizar os seguintes pontos de articulação para a subdivisão cabeça:
Pa_67 Boca
distanciamedia
Pa_68 Boca
distante
Pa_69 Boca
*/
    cout << "********************* Novo metodo PA: " << orientacaoMaoCheck << " *************************"<<endl;
    if (subdivisao.compare("cabeca") == 0) 
    {
        if (localizacao.compare("boca") == 0) 
	{
	    if(orientacaoMaoCheck.compare("Ori_1") == 0){
	    	return "Pa_6";
   	    }
 	    if(orientacaoMaoCheck.compare("Ori_2") == 0){
	    	return "Pa_67";
 	    }	
        } else if (localizacao.compare("olhodireito") == 0) {
            return "Pa_35";
        } else if (localizacao.compare("olhoesquerdo") == 0) {
            return "Pa_38";         
        } else if (localizacao.compare("orelhadireita") == 0) {
            return "Pa_50";
        } else if (localizacao.compare("queixo") == 0) {
            return "Pa_57";
        } else if (localizacao.compare("testa") == 0) {
            return "Pa_60";        
        } else return NULL;
    } else if (subdivisao.compare("tronco") == 0) {
        if (localizacao.compare("bustodireito") == 0) {
            return "Pa_15";
        } else if (localizacao.compare("bustoesquerdo") == 0) {
            return "Pa_18";
        }else if (localizacao.compare("cinturadireita") == 0) {
            return "Pa_24";
        }else if (localizacao.compare("cinturaesquerda") == 0) {
            return "Pa_27";
        }else if (localizacao.compare("umbigo") == 0) {
            return "Pa_66";
        }else if (localizacao.compare("ombrodireito") == 0) {
            return "Pa_44";
        } else return NULL;
    } 
    else if (subdivisao.compare("espaco-neutro") == 0) {
  	  
	if (localizacao.compare("bocamedia") == 0) { 
	    if(orientacaoMaoCheck.compare("Ori_1") == 0){
	    	return "Pa_7";
   	    }
 	    if(orientacaoMaoCheck.compare("Ori_2") == 0){
	    	return "Pa_68";
 	    }
	} else if (localizacao.compare("bocadistante") == 0) { 
	    if(orientacaoMaoCheck.compare("Ori_1") == 0){
	    	return "Pa_8";
   	    }
 	    if(orientacaoMaoCheck.compare("Ori_2") == 0){
	    	return "Pa_69";
 	    }
        } else if (localizacao.compare("bustodireitodistante") == 0) {
            return "Pa_17";
        } else if (localizacao.compare("bustodireitomedia") == 0) {
            return "Pa_16";
        } else if (localizacao.compare("bustoesquerdodistante") == 0) {
            return "Pa_20";
        } else if (localizacao.compare("bustoesquerdomedia") == 0) {
            return "Pa_19";
        } else if (localizacao.compare("cinturadireitadistante") == 0) {
            return "Pa_26";
        } else if (localizacao.compare("cinturadireitamedia") == 0) {
            return "Pa_25";
        } else if (localizacao.compare("cinturaesquerdamedia") == 0) {
            return "Pa_28";
        } else if (localizacao.compare("cinturaesquerdadistante") == 0) {
            return "Pa_29";
        } else if (localizacao.compare("olhodireitodistante") == 0) {
            return "Pa_37";
        } else if (localizacao.compare("olhodireitomedia") == 0) {
            return "Pa_36";
        } else if (localizacao.compare("olhoesquerdodistante") == 0) {
            return "Pa_40";
        } else if (localizacao.compare("olhoesquerdomedia") == 0) {
            return "Pa_39";
        } else if (localizacao.compare("ombrodireitodistante") == 0) {
            return "Pa_46";
        } else if (localizacao.compare("ombrodireitomedia") == 0) {
            return "Pa_45";
        } else if (localizacao.compare("ombroesquerdodistante") == 0) {
            return "Pa_49";
        } else if (localizacao.compare("ombroesquerdomedia") == 0) {
            return "Pa_48";
        } else if (localizacao.compare("orelhadireitadistante") == 0) {
            return "Pa_52";
        } else if (localizacao.compare("orelhadireitamedia") == 0) {
            return "Pa_51";
        } else if (localizacao.compare("testadistante") == 0) {
            return "Pa_62";
        } else if (localizacao.compare("testamedia") == 0) {
            return "Pa_61";
        } else{
	    cout << "***************** Parâmetros Ponto de Articulação Errados *****************" << endl;
       	    return NULL;

	}


    } else /*(subdivisao.compare("Perna") == 0)*/ {
	cout << "***************** Parâmetros Ponto de Articulação Errados *****************" << endl;
        return NULL;
    }

}

string PontoArticulacao::retornaStringCorrespondenteAoPontoArticulacao(string subdivisao, string localizacao) {

    if (subdivisao.compare("cabeca") == 0) {
        if (localizacao.compare("boca") == 0) {
            return "Pa_6";
        } else if (localizacao.compare("olhodireito") == 0) {
            return "Pa_35";
        } else if (localizacao.compare("olhoesquerdo") == 0) {
            return "Pa_38";         
        } else if (localizacao.compare("orelhadireita") == 0) {
            return "Pa_50";
        } else if (localizacao.compare("queixo") == 0) {
            return "Pa_57";
        } else if (localizacao.compare("testa") == 0) {
            return "Pa_60";        
        } else return NULL;
    } else if (subdivisao.compare("tronco") == 0) {
        if (localizacao.compare("bustodireito") == 0) {
            return "Pa_15";
        } else if (localizacao.compare("bustoesquerdo") == 0) {
            return "Pa_18";
        }else if (localizacao.compare("cinturadireita") == 0) {
            return "Pa_24";
        }else if (localizacao.compare("cinturaesquerda") == 0) {
            return "Pa_27";
        }else if (localizacao.compare("umbigo") == 0) {
            return "Pa_66";
        }else if (localizacao.compare("ombrodireito") == 0) {
            return "Pa_44";
        } else return NULL;
    } 
    else if (subdivisao.compare("espaco-neutro") == 0) {
  	  
          if (localizacao.compare("bocamedia") == 0) { 
            return "Pa_7";
        } else if (localizacao.compare("bustodireitodistante") == 0) {
            return "Pa_17";
        } else if (localizacao.compare("bustodireitomedia") == 0) {
            return "Pa_16";
        } else if (localizacao.compare("bustoesquerdodistante") == 0) {
            return "Pa_20";
        } else if (localizacao.compare("bustoesquerdomedia") == 0) {
            return "Pa_19";
        } else if (localizacao.compare("cinturadireitadistante") == 0) {
            return "Pa_26";
        } else if (localizacao.compare("cinturadireitamedia") == 0) {
            return "Pa_25";
        } else if (localizacao.compare("cinturaesquerdamedia") == 0) {
            return "Pa_28";
        } else if (localizacao.compare("cinturaesquerdadistante") == 0) {
            return "Pa_29";
        } else if (localizacao.compare("olhodireitodistante") == 0) {
            return "Pa_37";
        } else if (localizacao.compare("olhodireitomedia") == 0) {
            return "Pa_36";
        } else if (localizacao.compare("olhoesquerdodistante") == 0) {
            return "Pa_40";
        } else if (localizacao.compare("olhoesquerdomedia") == 0) {
            return "Pa_39";
        } else if (localizacao.compare("ombrodireitodistante") == 0) {
            return "Pa_46";
        } else if (localizacao.compare("ombrodireitomedia") == 0) {
            return "Pa_45";
        } else if (localizacao.compare("ombroesquerdodistante") == 0) {
            return "Pa_49";
        } else if (localizacao.compare("ombroesquerdomedia") == 0) {
            return "Pa_48";
        } else if (localizacao.compare("orelhadireitadistante") == 0) {
            return "Pa_52";
        } else if (localizacao.compare("orelhadireitamedia") == 0) {
            return "Pa_51";
        } else if (localizacao.compare("testadistante") == 0) {
            return "Pa_62";
        } else if (localizacao.compare("testamedia") == 0) {
            return "Pa_61";
        } else{
	    cout << "***************** Parâmetros Ponto de Articulação Errados *****************" << endl;
       	    return NULL;

	}


    } else /*(subdivisao.compare("Perna") == 0)*/ {
	cout << "***************** Parâmetros Ponto de Articulação Errados *****************" << endl;
        return NULL;
    }

}

PontoArticulacao::~PontoArticulacao() {
}

