/***************************************************************************
 *   Copyright (C) 2005 by Jeff Ferr                                       *
 *   root@sat                                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef J_MULTICAST_SOCKET_BUFFER_H
#define J_MULTICAST_SOCKET_BUFFER_H

#include <iostream>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdint.h>

namespace jsocket {

typedef struct sockaddr SA;

/**
 * \brief MulticastSocketBuffer.
 *
 * \author Jeff Ferr
 */
class MulticastSocketBuffer : public std::streambuf{

    private:
        /** \brief */
        int16_t _fds, _fdr;
        /** \brief */
        sockaddr_in _sock_s, _sock_r;
        /** \brief */
        char *_buffer_in;
        /** \brief */
        char *_buffer_out;
        /** \brief */
        uint64_t _sent_bytes;
        /** \brief */
        uint64_t _receive_bytes;
        /** \brief */
        uint64_t _size_buffer;

    public:
        /**
        * \brief
        *
        */
        MulticastSocketBuffer (int16_t fds_, int16_t fdr_, sockaddr_in sock_s_, sockaddr_in sock_r_, uint32_t size_ = 1024);
        
        /**
        * \brief
        *
        */
        virtual ~MulticastSocketBuffer();
        
        /**
        * \brief
        *
        */
        int sync();
        
        /**
        * \brief
        *
        */
        int overflow(int ch_ = traits_type::eof());
        
        /**
        * \brief
        *
        */
        int underflow();
        
        /**
        * \brief
        *
        */
        uint64_t GetSentBytes();
        
        /**
        * \brief
        *
        */
        uint64_t GetReceiveBytes();

};

};

#endif
