#include "jsocketoption.h"
#include "jsocket.h"
#include "jdatagramsocket.h"
#include "jsocketexception.h"
#include "jioexception.h"

#include <iostream>

using namespace jsocket;

int main() {
	char *buffer = new char[1024];
	char *receive = new char[1024];
	int size;

	memset(buffer, 0, 1024);
	memset(receive, 1, 1024);

	struct socket_time_t t;

	t.seconds = 2;
	t.micro_seconds = 0;
	
	try {
		Socket s("127.0.0.1", 80);

		SocketOption *o = s.GetSocketOption(); 
	
		o->SetReceiveTimeOut(t);

		o->SetSendMaximumBuffer(10240);
		o->SetReceiveMaximumBuffer(10240);
		
		std::cout << "Max1:" << o->GetSendMaximumBuffer() << std::endl;
		std::cout << "Max2:" << o->GetReceiveMaximumBuffer() << std::endl;
		
		size = s.Receive(receive, 1024);

		std::cout << "size: " << size << std::endl;

		delete o;
		
		s.Close();
	} catch (IOException &e) {
		std::cout << e.what() << std::endl;
	} catch (SocketException &e) {
		std::cout << e.what() << std::endl;
	} catch (...) {
		std::cout << "Unknown error !" << std::endl;
	}

	delete [] buffer;
	delete [] receive;
	
	return 0;
}
