/***************************************************************************
 *   Copyright (C) 2005 by Jeff Ferr                                       *
 *   root@sat                                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef J_SEMAPHORE_H
#define J_SEMAPHORE_H

#include "jthread.h"

#include <sys/types.h>
#include <stdint.h>
#include <semaphore.h>

namespace jthread {

/**
 * \brief Use struct timespec.
 *
 */
/*
struct semaphore_time_t {
	long seconds;
	long nano_seconds;
};
*/

/**
 * \brief Semaphore.
 *
 * @author Jeff Ferr
 */
class Semaphore {

    private:
        /** \brief Semaphore handler. */
        sem_t _semaphore;
        /** \brief */
	int16_t _count;

    public:
        /**
         * \brief Construtor.
         *
         */
        Semaphore(uint16_t = 0);

        /**
         * \brief Destrutor virtual.
         *
         */
        virtual ~Semaphore();

		/*
		 * \brief
		 *
		 */
		void Close();

        /**
         * \brief Lock the semaphore.
         *
         */
        void Wait();

		/**
		 * \brief Lock semaphore.
		 *
		 */
		void Wait(struct timespec time_);
		
        /**
         * \brief Notify the locked semaphore.
         *
         */
        void Notify();
        
        /**
         * \brief Try lock the semaphore.
         *
         */
        bool TryWait();
        
        /**
         * \brief
         *
         */
        int GetValue();
        
};

};

#endif
