/**
 *	compile: g++ teste.cpp -o teste -L. -ljthread -lpthread
 */

#include "jcondition.h"
#include "jsemaphore.h"
#include "jmutex.h"
#include "jthread.h"

#include <unistd.h>
#include <stdio.h>

#define NUM_THREADS	3
#define TCOUNT		10
#define COUNT_LIMIT	12

int count = 0;
bool init = false;
int thread_ids[3] = {0, 1, 2};

jthread::Mutex monitor;
jthread::Condition sem, i1, w1;

class IncCount : public jthread::Thread {
	private:
		int id;

	public:
		IncCount(int i) {
			id = i;
		}
		
		void Run() {
			int i;

			for (i=0; i<TCOUNT; i++) {
				monitor.Lock();

				count++;

				if (count == COUNT_LIMIT) {
					sem.Notify();
				}
					
				// printf("inc: thread %d, count %d, unlock mutex.\n", id, count);

				monitor.Unlock();

			}
			
			i1.Notify();
		}

};

class WatchCount : public jthread::Thread {
	private:
		int id, c;

	public:
		WatchCount(int i) {
			id = i;
			c = 0;
		}

		void Run() {
			// printf("Starting watch count: thread %d\n", id);
			
			printf(".");

			while (count < COUNT_LIMIT) {
				sem.Wait();

				// printf("Watch count: thread %d, count %d, condition signal received.\n", id, count);
				printf("|");
			}

			w1.Notify();
		}
		
};

int main() {
	try {
	IncCount *inc1, *inc2;
	WatchCount *watch1;

	inc1 = new IncCount(thread_ids[0]);
	inc2 = new IncCount(thread_ids[1]);
	watch1 = new WatchCount(thread_ids[2]);

	watch1->Start();
	usleep(10);
	inc1->Start();
	inc2->Start();

	// watch1->Interrupt();

	w1.Wait();
	i1.Wait();

	delete inc1;
	delete inc2;
	delete watch1;
	} catch (...) {
		printf("Puta que paril, pq essa merda chegou aqui !\n\n");
	}
	
	return 0;
}
